#!/bin/bash

if [ $# -ne 1 ]; then
    echo usa: $(basename $0) filename
    exit 1
fi

exec 0<$1   # in numero di descrittore 0 puo' essere omesso

n=0
while read -a line; do   # l'opzione -a crea line come un array
    (( n += ${#line[@]} )) # conto il numero di parole nell'array
done

# se il file non termina con una linea vuota, il ciclo while non conta le parole dell'ultima
# riga, quindi e' necessario controllare quest'ultimo caso
if [ ${#line[@]} -gt 0 ]; then
    (( n += ${#line[@]} ))
fi
# VERSIONE ALTERNATIVA con un unico ciclo while
# while read line || [ -n "$line" ]; do
#    read -a array <<< $line   # creo un array da una stringa ( man bash "Here String")
#    (( n += ${#line[@]} ))
# fi


echo "numero di parole: " $n
